package com.yeejoin.equipmanage.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.yeejoin.equipmanage.common.entity.ExtinguishantOnCar;
import com.yeejoin.equipmanage.common.utils.NameUtils;
import com.yeejoin.equipmanage.service.IExtinguishantOnCarService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.util.ReflectionUtils;
import org.springframework.web.bind.annotation.*;
import org.typroject.tyboot.core.foundation.enumeration.UserType;
import org.typroject.tyboot.core.restful.doc.TycloudOperation;

import javax.servlet.http.HttpServletRequest;
import java.util.Arrays;


/**
 * 
 *
 * @author wujiang
 * @date 2020-07-07
 */
@RestController
@Api(tags = "车辆灭火药剂Api")
@RequestMapping(value = "/extinguishant-on-car", produces = MediaType.APPLICATION_JSON_UTF8_VALUE)
public class ExtinguishantOnCarController {

  @Autowired
  IExtinguishantOnCarService iExtinguishantOnCarService;


    /**
    * 新增
    * @return
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @TycloudOperation(ApiLevel = UserType.AGENCY)
    @ApiOperation(httpMethod = "POST", value = "新增", notes = "新增")
    public boolean saveExtinguishantOnCar(HttpServletRequest request, @RequestBody ExtinguishantOnCar extinguishantOnCar){
    return iExtinguishantOnCarService.save(extinguishantOnCar);
    }

    /**
    * 根据id删除
    * @param id
    * @return
    */
    @RequestMapping(value = "/{id}", method = RequestMethod.DELETE)
    @TycloudOperation(ApiLevel = UserType.AGENCY)
    @ApiOperation(httpMethod = "DELETE", value = "根据id删除", notes = "根据id删除")
    public boolean deleteById(HttpServletRequest request, @PathVariable Long id){
    return iExtinguishantOnCarService.removeById(id);
    }


    /**
    * 修改
    * @return
    */
    @RequestMapping(value = "/updateById", method = RequestMethod.PUT)
    @TycloudOperation(ApiLevel = UserType.AGENCY)
    @ApiOperation(httpMethod = "PUT", value = "修改", notes = "修改")
    public boolean updateByIdExtinguishantOnCar(HttpServletRequest request, @RequestBody ExtinguishantOnCar extinguishantOnCar){
    return iExtinguishantOnCarService.updateById(extinguishantOnCar);
    }



    /**
   * 根据id查询
   * @param id
   * @return
   */
   @RequestMapping(value = "/{id}", method = RequestMethod.GET)
       @TycloudOperation(ApiLevel = UserType.AGENCY)
    @ApiOperation(httpMethod = "GET", value = "根据id查询", notes = "根据id查询")
   public ExtinguishantOnCar selectById(HttpServletRequest request, @PathVariable Long id){
      return iExtinguishantOnCarService.getById(id);
   }



  /**
  * 列表分页查询
  * @return
  */
  @RequestMapping(value = "/list", method = RequestMethod.GET)
      @TycloudOperation(ApiLevel = UserType.AGENCY)
    @ApiOperation(httpMethod = "GET", value = "列表分页查询", notes = "列表分页查询")
  public IPage<ExtinguishantOnCar> listPage(String pageNum,String pageSize,
    ExtinguishantOnCar extinguishantOnCar){

    Page<ExtinguishantOnCar> pageBean;
    QueryWrapper<ExtinguishantOnCar> extinguishantOnCarQueryWrapper = new QueryWrapper<>();
    Class<? extends ExtinguishantOnCar> aClass = extinguishantOnCar.getClass();
    Arrays.stream(aClass.getDeclaredFields()).forEach(field -> {
        try {
            ReflectionUtils.makeAccessible(field);
            Object o = field.get(extinguishantOnCar);
            if (o != null) {
                Class<?> type = field.getType();
                String name = NameUtils.camel2Underline(field.getName());
                if (type.equals(Integer.class)) {
                Integer fileValue = (Integer) field.get(extinguishantOnCar);
                extinguishantOnCarQueryWrapper.eq(name, fileValue);
                } else if (type.equals(Long.class)) {
                Long fileValue = (Long) field.get(extinguishantOnCar);
                extinguishantOnCarQueryWrapper.eq(name, fileValue);
                } else if (type.equals(String.class)) {
                String fileValue = (String) field.get(extinguishantOnCar);
                extinguishantOnCarQueryWrapper.eq(name, fileValue);
                } else {
                String fileValue = (String) field.get(extinguishantOnCar);
                extinguishantOnCarQueryWrapper.eq(name, fileValue);
            }
          }
        }catch (Exception e) {
        }
    });
    IPage<ExtinguishantOnCar> page;
    if (StringUtils.isBlank(pageNum)  ||StringUtils.isBlank(pageSize)) {
        pageBean = new Page<>(0, Long.MAX_VALUE);
    }else{
        pageBean = new Page<>(Integer.parseInt(pageNum), Integer.parseInt(pageSize));
    }
    page = iExtinguishantOnCarService.page(pageBean, extinguishantOnCarQueryWrapper);
    return page;
  }
}


